;; This procedure curries a function,
;; e.g. it takes a function of two
;; inputs and returns a function of
;; one input, that returns a function
;; of one input, that does the same
;; thing
;; ex: (+ 1 2) ==> 3
;; (((curry +) 1) 2) ==> 3
(define (curry f)
  (lambda (x)
    (lambda (y)
      (f x y))))